;========================================================
; Yoshi "Animal Buddy"
;
; Description: This sprite makes Mario turn into Yoshi,
; similar to how Animal Buddies worked in Donkey Kong
; Country 2.
; This sprite is the main "box"; touching it will start
; the entire code handling.
; Set the Extra Byte 1 to 80 to make this the No Yoshi
; sign, which will morph Yoshi back into Mario.
;========================================================

!hitpoints    = $02         ;   total "lives", minus one (eg $02 allows to be hit thrice)
!freeram      = $1473|!addr
!freeram2     = $15E8|!addr
box_tilemap:
       db $00,$02,$46,$48

print "INIT ",pc
       LDA !7FAB40,x
       BPL +
       LDA #$2B
       STA !1662,x
       RTL
+      STZ $1473|!addr
       STZ $0DC2|!addr
       LDA #$08
       STA !14C8+!SprSize-1
       LDA !7FAB9E,x
       STA !7FAB9E+!SprSize-1
       LDA !7FAB10,x
       STA !7FAB10+!SprSize-1
       LDX.b #!SprSize-1
       JSL.l read3($0187A8)
       LDX $15E9|!addr
       LDA !D8,x
       STA !D8+!SprSize-1
       LDA !E4,x
       STA !E4+!SprSize-1
       LDA !14D4,x
       STA !14D4+!SprSize-1
       LDA !14E0,x
       STA !14E0+!SprSize-1
       STZ !14C8,x
       RTL
       

print "MAIN ",pc
       PHB
       PHK
       PLB
       LDA !7FAB40,x
       BPL +
       JSR no_yoshi_main
+      LDA $187A|!addr
       BEQ box
       PEA.w handler_return-1
       JMP yoshi_buddy_main
box:
       JSR box_main
handler_return:
       PLB
       RTL

;   "Box"/Preparing
box_main:
       JSR draw_box
       LDA !1540,x
       BEQ +
       DEC
       BEQ .end
       LDA #$FF
       STA $78
       STZ $15
       STZ $16
       STZ $17
       STZ $18
       STZ $7B
       STZ $7D
       RTS
+      JSL SMW_SpriteMarioInteraction|!bankB
       BCC .return
       LDA #$18
       STA !1540,x
.return
       RTS

.return2
       LDX $15E9|!addr
       RTS
.end
       LDX.b #!SprSize-2
       LDA !9E,x
       CMP #$35
       BEQ .return2
       LDA #$35
       STA !9E,x
       JSL $07F7D2|!bankB
       LDA #$08
       STA !14C8,x
       LDA $94
       STA !E4,x
       LDA $95
       STA !14E0,x
       LDA $96
       CLC
       ADC #$08
       STA !D8,x
       LDA $97
       ADC #$00
       STA !14D4,x
       INC !freeram
       LDX $15E9|!addr
       INC $187A|!addr
       LDA.b #!hitpoints
       STA !1FD6,x
       DEX
       RTS

draw_box:
       JSL GetDrawInfo
       LDX #$03
-      LDA $00
       CLC
       ADC box_xdisp,x
       STA $0300|!addr,y
       LDA $01
       CLC
       ADC box_ydisp,x
       STA $0301|!addr,y
       LDA box_tilemap,x
       STA $0302|!addr,y
       LDA #$3B
       STA $0303|!addr,y
       INY #4
       DEX
       BPL -
       LDX $15E9|!addr
       LDY #$02
       LDA #$03
       JSL SMW_SpriteFinishOAMWrite|!bankB
       RTS

box_xdisp:
       db $00,$10,$00,$10
box_ydisp:
       db $00,$00,$10,$10

;   Morphed into a Yoshi
yoshi_buddy_main:
       LDA #$7F
       STA $78
       LDA !freeram2
       BEQ .sync
       LDA !1FD6,x
       CMP !freeram2
       BEQ .sync
       LDA !freeram2
       STA !1FD6,x
.sync
       LDA !1FD6,x
       STA !freeram2
       LDA $9D
       BNE .return
       JSR draw_hitpoints
       LDA !freeram
       BPL .return
       LDA #$80
       TRB !freeram
       DEC !1FD6,x
       DEC !freeram2
       BPL .return
       JSL SMW_KillMario
.return
       RTS

draw_hitpoints:
       LDY !freeram2
       BEQ .not_bother
       DEY
       JSR find_free_slot
       STZ $00
-      LDA #$08
       CLC
       ADC $00
       STA $0200|!addr,x
       LDA #$C8
       STA $0201|!addr,x
       LDA #$24
       STA $0202|!addr,x
       LDA #$38
       STA $0203|!addr,x
       PHX
       TXA
       LSR #2
       TAX
       LDA #$02
       STA $0420|!addr,x
       PLX
       INX #4
       LDA $00
       CLC
       ADC #$18
       STA $00
       DEY
       BPL -
       LDX $15E9|!addr
.not_bother
       RTS

find_free_slot:
       LDX #$00
-      LDA $0201|!addr,x
       CMP #$F0
       BEQ .break
       INX #4
       BNE -
       LDX #$00
.break
       RTS

;   No Yoshi sign
no_yoshi_main:
       JSL GetDrawInfo
       LDA !1540,x
       BEQ ++
       DEC
       BEQ .end
       STZ $15
       STZ $16
       STZ $17
       STZ $18
       STZ $7B
       STZ $7D
       RTS
++     JSL SMW_SpriteMarioInteraction|!bankB
       BCC .return
       LDA #$18
       STA !1540,x
.return
       RTS

.return2
       LDX $15E9|!addr
       RTS
.end
       STZ !freeram
       STZ $187A|!addr
       STZ $0DC1|!addr
       LDX.b #!SprSize-1
-      LDA !9E,x
       CMP #$35
       BNE +
       STZ !14C8,x
+      DEX
       BPL -
       LDX $15E9|!addr
       STZ !14C8,x
       LDA #$10
       STA $1DF9|!addr
       RTS


pushpc
       org $01F713
              autoclean JML lose_yoshi_check
       org $01ED9A
              autoclean JML leave_yoshi_check
       org $00D656
              autoclean JML spinjump_check
       org $01F6EC
              autoclean JSL yoshi_interact_check
              NOP
       org $01ED0C
              autoclean JSL ceiling_fix
              NOP
       org $01EF26
              autoclean JML offset_yoshi_check
       org $01F412
              autoclean JSL offset_tongue_check
       org $00EB79
              autoclean JML clipping_check_1
       org $01B4C0
              autoclean JML clipping_check_2
       org $03B664
              autoclean JML clipping_check_3
       org $01F54F
              autoclean JSL tongue_clipping_check
       org $01F505
              autoclean JSL offset_eaten_sprite
       org $01F083
              autoclean JSL offset_throat_tile
       org $00FE82
              autoclean JML offset_turning_smoke

freedata
lose_yoshi_check:
       LDA !freeram
       BEQ .return
       LDA $1497|!addr
       BNE +
       LDA #$03
       STA $1DFA|!addr
       LDA #$13
       STA $1DFC|!addr
       LDA #$80
       TSB !freeram
       LDA #$30
       STA $1497|!addr
+      JML $01F74B|!bankB
.return
       LDA #$10
       STA !163E,x
       JML $01F718|!bankB

leave_yoshi_check:
       BIT $18
       BPL .return
       LDA !freeram
       BEQ +
.return
       JML $01EDCB|!bankB
+      JML $01ED9E|!bankB

spinjump_check:
       LDA !freeram
       BEQ .normal
-      JML $00D65B|!bankB
.normal
       LDA $187A
       BEQ -
       JML $00D682|!bankB

offset_yoshi_check:
       LDA !D8,x
       PHA
       LDA !freeram
       BNE .offset
       LDA $01,s
       CLC
       JML $01EF2A|!bankB

.offset
       LDA !14D4,x
       PHA
       LDA $96
       PHY
       LDY $73
       BNE .duck
       BIT !freeram
       BVC .store
.cont
       LDY #$01
       STY !freeram
.duck
       CLC
       ADC #$03
.store
       STA !D8,x
       PLY
       LDA $97
       JML $01EF35|!bankB

offset_tongue_check:
       CLC
       ADC !D8,x
       PHX
       LDX !freeram
       BEQ .not_add
       LDX #$41
       STX !freeram
       SEC
       SBC #$12
       PHA
       LDA $15
       AND #$08
       BNE .store
       LDX $13EF|!addr
       BNE +
.store
       PLA
       CLC
       ADC #$02
       LDX #$01
       STX !freeram
       BRA .not_add
+      PLA
.not_add
       PLX
       SEC
       RTL

offset_eaten_sprite:
       BPL +
       DEC $01
+      PHX
       LDX !freeram
       BEQ .not_add
       SEC
       SBC #$14
       BPL .not_add
       DEC $01
.not_add
       PLX
       RTL

offset_throat_tile:
       ADC $03C19E,x
       LDY !freeram
       BEQ +
       SEC
       SBC #$10
+      RTL

tongue_clipping_check:
       CLC
       ADC #$02
       PHX
       LDX !freeram
       BEQ .not_add
       SEC
       SBC #$14
.not_add
       PLX
       CLC
       RTL

clipping_check_1:
       LDA !freeram
       BNE .custom
-      LDA $19
       BEQ +
       JML $00EB7D|!bankB
+      JML $00EB83|!bankB

.custom
       LDA $18DF|!addr
       BEQ -
       LDA $96
       SEC
       SBC #$10
       AND #$0F
       STA $90
       LDA $94
       AND #$0F
       TAY
       CLC
       ADC #$08
       AND #$0F
       STA $92
       STZ $93
       CPY #$08
       BCC +
       LDX #$0C
       INC $93
       CLC
+      LDA $90
       ADC.l $00E8A4,x
       AND #$0F
       STA $91
       JML $00EBAF|!bankB

clipping_check_2:
       LDA !freeram
       BNE .custom
       LDY $19
       BNE +
       JML $01B4C4|!bankB
+      JML $01B4C6|!bankB

.custom
       LDA #$08
       JML $01B4CD|!bankB

clipping_check_3:
       PHX
       LDA !freeram
       BNE .custom
-      LDA $94
       CLC
       JML $03B668|!addr

.custom
       LDX $18DF|!addr
       BEQ -
       LDA $94
       CLC
       ADC #$02
       STA $00
       LDA $95
       ADC #$00
       STA $08
       LDA #$0C
       STA $02
       STA $03
       LDA $96
       CLC
       ADC #$14
       STA $01
       LDA $97
       ADC #$00
       STA $09
       PLX
       RTL

yoshi_interact_check:
       LDA !freeram
       BEQ .return
       LDA $05
       SEC
       SBC #$10
.return
       CLC
       ADC #$0D
       RTL

offset_turning_smoke:
       PHX
       LDX !freeram
       BNE .offset
       LDX $187A|!addr
       JML $00FE86|!bankB

.offset
       JML $00FE8A|!bankB

ceiling_fix:
       LDA !1588,x
       AND #$08
       BEQ +
       STZ !AA,x
+      LDA #$04
       CLC
       ADC !E4,x
       RTL
pullpc

